package com.company.ftablefocus.web.screens.project;

import com.haulmont.cuba.core.global.DatatypeFormatter;
import com.haulmont.cuba.gui.UiComponents;
import com.haulmont.cuba.gui.components.GroupTable;
import com.haulmont.cuba.gui.components.Label;
import com.haulmont.cuba.gui.screen.*;
import com.company.ftablefocus.entity.Project;

import javax.inject.Inject;

@UiController("ftablefocus_Project.browse")
@UiDescriptor("project-browse.xml")
@LookupComponent("projectsTable")
@LoadDataBeforeShow
public class ProjectBrowse extends StandardLookup<Project> {

    @Inject
    private GroupTable<Project> projectsTable;

    @Inject
    private UiComponents uiComponents;

    @Inject
    private DatatypeFormatter datatypeFormatter;

    @Subscribe
    public void onInit(InitEvent event) {
        projectsTable.addGeneratedColumn("name", entity -> {
            Label<String> label = uiComponents.create(Label.NAME);
            label.setValue(entity.getName());
            return label;
        });

        projectsTable.addGeneratedColumn("endDate", entity -> {
            Label<String> label = uiComponents.create(Label.NAME);
            label.setValue(datatypeFormatter.formatDateTime(entity.getEndDate()));
            return label;
        });
    }
}